# Models Library

Currently library consists of 296 scalar models in AMPL, GAMS and Pyomo formats. It is built using sample models available in the [GAMS Model Library](https://www.gams.com/latest/gamslib_ml/libhtml/index.html). 

Main characteristics of a models:

- number of equations;
- number of variables;
- number of discrete variables;
- number of nonzero elements;
- number of nonlinear nonzero elements.

|ID|Model|Type|Description|Files|Eq|Vars|Vars Disc|Non zero|Non zero NL|
|---|---|---|---|---|---|---|---|---|---|
|1|[trnsport](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_trnsport.html)|LP|A Transportation Problem|[mod](trnsport/trnsport-scalar.mod) [gms](trnsport/trnsport-scalar.gms) [py](trnsport/trnsport-scalar.py) [jl](trnsport/trnsport-scalar.jl)|6|7|0|19|0|
|2|[blend](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_blend.html)|LP|Blending Problem I|[mod](blend/blend-scalar.mod) [gms](blend/blend-scalar.gms) [py](blend/blend-scalar.py) [jl](blend/blend-scalar.jl)|4|10|0|37|0|
|3|[prodmix](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_prodmix.html)|LP|A Production Mix Problem|[mod](prodmix/prodmix-scalar.mod) [gms](prodmix/prodmix-scalar.gms) [py](prodmix/prodmix-scalar.py) [jl](prodmix/prodmix-scalar.jl)|3|5|0|13|0|
|4|[whouse](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_whouse.html)|LP|Simple Warehouse Problem|[mod](whouse/whouse-scalar.mod) [gms](whouse/whouse-scalar.gms) [py](whouse/whouse-scalar.py) [jl](whouse/whouse-scalar.jl)|5|13|0|28|0|
|5|[jobt](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_jobt.html)|LP|On-the-Job Training|[mod](jobt/jobt-scalar.mod) [gms](jobt/jobt-scalar.gms) [py](jobt/jobt-scalar.py) [jl](jobt/jobt-scalar.jl)|16|31|0|73|0|
|6|[sroute](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_sroute.html)|LP|The Shortest Route Problem|[mod](sroute/sroute-scalar.mod) [gms](sroute/sroute-scalar.gms) [py](sroute/sroute-scalar.py) [jl](sroute/sroute-scalar.jl)|73|307|0|851|0|
|7|[diet](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_diet.html)|LP|Stigler's Nutrition Model|[mod](diet/diet-scalar.mod) [gms](diet/diet-scalar.gms) [py](diet/diet-scalar.py) [jl](diet/diet-scalar.jl)|10|21|0|180|0|
|8|[aircraft](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_aircraft.html)|LP|Aircraft Allocation Under Uncertain Demand|[mod](aircraft/aircraft-scalar.mod) [gms](aircraft/aircraft-scalar.gms) [py](aircraft/aircraft-scalar.py) [jl](aircraft/aircraft-scalar.jl)|12|43|0|99|0|
|9|[prodsch](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_prodsch.html)|MIP|APEX - Production Scheduling Model|[mod](prodsch/prodsch-scalar.mod) [gms](prodsch/prodsch-scalar.gms) [py](prodsch/prodsch-scalar.py) [jl](prodsch/prodsch-scalar.jl)|89|118|41|384|0|
|10|[pdi](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pdi.html)|LP|ARCNET - Production Distribution and Inventory|[mod](pdi/pdi-scalar.mod) [gms](pdi/pdi-scalar.gms) [py](pdi/pdi-scalar.py) [jl](pdi/pdi-scalar.jl)|69|134|0|396|0|
|11|[uimp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_uimp.html)|LP|UIMP - Production Scheduling Problem|[mod](uimp/uimp-scalar.mod) [gms](uimp/uimp-scalar.gms) [py](uimp/uimp-scalar.py) [jl](uimp/uimp-scalar.jl)|21|43|0|116|0|
|12|[magic](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_magic.html)|MIP|Magic Power Scheduling Problem|[mod](magic/magic-scalar.mod) [gms](magic/magic-scalar.gms) [py](magic/magic-scalar.py) [jl](magic/magic-scalar.jl)|56|46|15|181|0|
|13|[ferts](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ferts.html)|LP|Egypt - Static Fertilizer Model|[mod](ferts/ferts-scalar.mod) [gms](ferts/ferts-scalar.gms) [py](ferts/ferts-scalar.py) [jl](ferts/ferts-scalar.jl)|174|361|0|1|0|
|14|[fertd](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_fertd.html)|MIP|Egypt - Dynamic Fertilizer Model|[mod](fertd/fertd-scalar.mod) [gms](fertd/fertd-scalar.gms) [py](fertd/fertd-scalar.py) [jl](fertd/fertd-scalar.jl)|458|2|3|7|0|
|15|[mexss](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mexss.html)|LP|Mexico Steel - Small Static|[mod](mexss/mexss-scalar.mod) [gms](mexss/mexss-scalar.gms) [py](mexss/mexss-scalar.py) [jl](mexss/mexss-scalar.jl)|74|78|0|230|0|
|16|[mexsd](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mexsd.html)|MIP|Mexico Steel - Small Dynamic|[mod](mexsd/mexsd-scalar.mod) [gms](mexsd/mexsd-scalar.gms) [py](mexsd/mexsd-scalar.py) [jl](mexsd/mexsd-scalar.jl)|820|1|112|5|0|
|17|[mexls](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mexls.html)|LP|Mexico Steel - Large Static|[mod](mexls/mexls-scalar.mod) [gms](mexls/mexls-scalar.gms) [py](mexls/mexls-scalar.py) [jl](mexls/mexls-scalar.jl)|353|578|0|1|0|
|18|[weapons](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_weapons.html)|NLP|Weapons Assignment|[mod](weapons/weapons-scalar.mod) [gms](weapons/weapons-scalar.gms) [py](weapons/weapons-scalar.py) [jl](weapons/weapons-scalar.jl)|13|66|0|156|65|
|19|[bid](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_bid.html)|MIP|Bid Evaluation|[mod](bid/bid-scalar.mod) [gms](bid/bid-scalar.gms) [py](bid/bid-scalar.py) [jl](bid/bid-scalar.jl)|25|19|9|68|0|
|20|[process](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_process.html)|NLP|Alkylation Process Optimization|[mod](process/process-scalar.mod) [gms](process/process-scalar.gms) [py](process/process-scalar.py) [jl](process/process-scalar.jl)|8|11|0|28|11|
|21|[chem](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_chem.html)|NLP|Chemical Equilibrium Problem|[mod](chem/chem-scalar.mod) [gms](chem/chem-scalar.gms) [py](chem/chem-scalar.py) [jl](chem/chem-scalar.jl)|5|12|0|37|11|
|22|[ship](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ship.html)|NLP|Structural Optimization|[mod](ship/ship-scalar.mod) [gms](ship/ship-scalar.gms) [py](ship/ship-scalar.py) [jl](ship/ship-scalar.jl)|18|11|0|55|29|
|23|[linear](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_linear.html)|DNLP|Linear Regression with Various Criteria|[mod](linear/linear-scalar.mod) [gms](linear/linear-scalar.gms) [py](linear/linear-scalar.py) [jl](linear/linear-scalar.jl)|21|25|0|121|20|
|24|[least](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_least.html)|NLP|Nonlinear Regression Problem|[mod](least/least-scalar.mod) [gms](least/least-scalar.gms) [py](least/least-scalar.py) [jl](least/least-scalar.jl)|1|4|0|4|3|
|25|[like](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_like.html)|NLP|Maximum Likelihood Estimation|[mod](like/like-scalar.mod) [gms](like/like-scalar.gms) [py](like/like-scalar.py) [jl](like/like-scalar.jl)|4|10|0|17|9|
|26|[chance](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_chance.html)|NLP|Chance Constrained Feed Mix Problem|[mod](chance/chance-scalar.mod) [gms](chance/chance-scalar.gms) [py](chance/chance-scalar.py) [jl](chance/chance-scalar.jl)|4|5|0|17|4|
|27|[sample](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_sample.html)|NLP|Stratified Sample Design|[mod](sample/sample-scalar.mod) [gms](sample/sample-scalar.gms) [py](sample/sample-scalar.py) [jl](sample/sample-scalar.jl)|3|5|0|13|8|
|28|[pindyck](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pindyck.html)|NLP|Optimal Pricing and Extraction for OPEC|[mod](pindyck/pindyck-scalar.mod) [gms](pindyck/pindyck-scalar.gms) [py](pindyck/pindyck-scalar.py) [jl](pindyck/pindyck-scalar.jl)|97|117|0|337|80|
|30|[vietman](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_vietman.html)|MIP|Vietoriscz Manne Fertilizer Model 1961|[mod](vietman/vietman-scalar.mod) [gms](vietman/vietman-scalar.gms) [py](vietman/vietman-scalar.py) [jl](vietman/vietman-scalar.jl)|28|113|10|370|0|
|32|[marco](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_marco.html)|LP|Mini Oil Refining Model|[mod](marco/marco-scalar.mod) [gms](marco/marco-scalar.gms) [py](marco/marco-scalar.py) [jl](marco/marco-scalar.jl)|46|61|0|237|0|
|33|[chenery](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_chenery.html)|NLP|Substitution and Structural Change|[mod](chenery/chenery-scalar.mod) [gms](chenery/chenery-scalar.gms) [py](chenery/chenery-scalar.py) [jl](chenery/chenery-scalar.jl)|39|44|0|133|56|
|34|[pak](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pak.html)|LP|Optimal Patterns of Growth and Aid|[mod](pak/pak-scalar.mod) [gms](pak/pak-scalar.gms) [py](pak/pak-scalar.py) [jl](pak/pak-scalar.jl)|348|284|0|950|0|
|36|[himmel16](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_himmel16.html)|NLP|Area of Hexagon Test Problem|[mod](himmel16/himmel16-scalar.mod) [gms](himmel16/himmel16-scalar.gms) [py](himmel16/himmel16-scalar.py) [jl](himmel16/himmel16-scalar.jl)|22|19|0|97|84|
|37|[robert](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_robert.html)|LP|Elementary Production and Inventory Model|[mod](robert/robert-scalar.mod) [gms](robert/robert-scalar.gms) [py](robert/robert-scalar.py) [jl](robert/robert-scalar.jl)|10|18|0|57|0|
|38|[rdata](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_rdata.html)|MIP|Sample Database of the US Economy|[mod](rdata/rdata-scalar.mod) [gms](rdata/rdata-scalar.gms) [py](rdata/rdata-scalar.py) [jl](rdata/rdata-scalar.jl)|51|49|5|178|0|
|39|[mine](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mine.html)|LP|Opencast Mining|[mod](mine/mine-scalar.mod) [gms](mine/mine-scalar.gms) [py](mine/mine-scalar.py) [jl](mine/mine-scalar.jl)|57|31|0|135|0|
|40|[orani](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_orani.html)|LP|A Miniature Version of Orani 78|[mod](orani/orani-scalar.mod) [gms](orani/orani-scalar.gms) [py](orani/orani-scalar.py) [jl](orani/orani-scalar.jl)|40|52|0|170|0|
|41|[prolog](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_prolog.html)|NLP|Market Equilibrium and Activity Analysis|[mod](prolog/prolog-scalar.mod) [gms](prolog/prolog-scalar.gms) [py](prolog/prolog-scalar.py) [jl](prolog/prolog-scalar.jl)|23|21|0|129|14|
|42|[cube](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cube.html)|MIP|Three-Dimensional Noughts and Crosses|[mod](cube/cube-scalar.mod) [gms](cube/cube-scalar.gms) [py](cube/cube-scalar.py) [jl](cube/cube-scalar.jl)|100|77|27|469|0|
|43|[chakra](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_chakra.html)|NLP|Optimal Growth Model|[mod](chakra/chakra-scalar.mod) [gms](chakra/chakra-scalar.gms) [py](chakra/chakra-scalar.py) [jl](chakra/chakra-scalar.jl)|42|63|0|143|41|
|44|[andean](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_andean.html)|MIP|Andean Fertilizer Model|[mod](andean/andean-scalar.mod) [gms](andean/andean-scalar.gms) [py](andean/andean-scalar.py) [jl](andean/andean-scalar.jl)|87|68|30|204|0|
|45|[copper](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_copper.html)|MIP|Modeling Investment in the World Copper Industry|[mod](copper/copper-scalar.mod) [gms](copper/copper-scalar.gms) [py](copper/copper-scalar.py) [jl](copper/copper-scalar.jl)|476|1|84|5|0|
|47|[otpop](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_otpop.html)|NLP|OPEC Trade and Production|[mod](otpop/otpop-scalar.mod) [gms](otpop/otpop-scalar.gms) [py](otpop/otpop-scalar.py) [jl](otpop/otpop-scalar.jl)|77|104|0|285|100|
|48|[korpet](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_korpet.html)|MIP|Investment Planning in the Korean Oil-Petro Industry|[mod](korpet/korpet-scalar.mod) [gms](korpet/korpet-scalar.gms) [py](korpet/korpet-scalar.py) [jl](korpet/korpet-scalar.jl)|1|1|81|6|0|
|49|[sarf](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_sarf.html)|LP|Farm Credit and Income Distribution Model|[mod](sarf/sarf-scalar.mod) [gms](sarf/sarf-scalar.gms) [py](sarf/sarf-scalar.py) [jl](sarf/sarf-scalar.jl)|532|542|0|3|0|
|50|[port](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_port.html)|LP|Simple Portfolio Model|[mod](port/port-scalar.mod) [gms](port/port-scalar.gms) [py](port/port-scalar.py) [jl](port/port-scalar.jl)|5|7|0|27|0|
|51|[yemcem](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_yemcem.html)|MIP|Yemen Cement Model|[mod](yemcem/yemcem-scalar.mod) [gms](yemcem/yemcem-scalar.gms) [py](yemcem/yemcem-scalar.py) [jl](yemcem/yemcem-scalar.jl)|168|258|53|953|0|
|52|[srcpm](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_srcpm.html)|NLP|Single-Region Contingency Planning Model|[mod](srcpm/srcpm-scalar.mod) [gms](srcpm/srcpm-scalar.gms) [py](srcpm/srcpm-scalar.py) [jl](srcpm/srcpm-scalar.jl)|27|39|0|156|5|
|53|[gtm](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gtm.html)|NLP|International Gas Trade Model|[mod](gtm/gtm-scalar.mod) [gms](gtm/gtm-scalar.gms) [py](gtm/gtm-scalar.py) [jl](gtm/gtm-scalar.jl)|25|64|0|162|20|
|54|[turkpow](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_turkpow.html)|LP|Turkey Power Planning Model|[mod](turkpow/turkpow-scalar.mod) [gms](turkpow/turkpow-scalar.gms) [py](turkpow/turkpow-scalar.py) [jl](turkpow/turkpow-scalar.jl)|350|949|0|5|0|
|56|[china](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_china.html)|LP|Organic Fertilizer Use in Intensive Farming|[mod](china/china-scalar.mod) [gms](china/china-scalar.gms) [py](china/china-scalar.py) [jl](china/china-scalar.jl)|52|67|0|602|0|
|57|[tabora](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tabora.html)|LP|Tabora Rural Development - Fuelwood Production|[mod](tabora/tabora-scalar.mod) [gms](tabora/tabora-scalar.gms) [py](tabora/tabora-scalar.py) [jl](tabora/tabora-scalar.jl)|573|571|0|2|0|
|58|[westmip](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_westmip.html)|MIP|Economies of Scale and Investment over Time|[mod](westmip/westmip-scalar.mod) [gms](westmip/westmip-scalar.gms) [py](westmip/westmip-scalar.py) [jl](westmip/westmip-scalar.jl)|4|4|20|10|0|
|59|[imsl](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_imsl.html)|LP|Piecewise Linear Approximation|[mod](imsl/imsl-scalar.mod) [gms](imsl/imsl-scalar.gms) [py](imsl/imsl-scalar.py) [jl](imsl/imsl-scalar.jl)|62|134|0|359|0|
|60|[ajax](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ajax.html)|LP|Ajax Paper Company Production Schedule|[mod](ajax/ajax-scalar.mod) [gms](ajax/ajax-scalar.gms) [py](ajax/ajax-scalar.py) [jl](ajax/ajax-scalar.jl)|8|13|0|37|0|
|61|[tforss](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tforss.html)|LP|Antalya Forestry Model - Steady State|[mod](tforss/tforss-scalar.mod) [gms](tforss/tforss-scalar.gms) [py](tforss/tforss-scalar.py) [jl](tforss/tforss-scalar.jl)|21|64|0|215|0|
|62|[tfordy](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tfordy.html)|LP|Antalya Forestry Model - Dynamic|[mod](tfordy/tfordy-scalar.mod) [gms](tfordy/tfordy-scalar.gms) [py](tfordy/tfordy-scalar.py) [jl](tfordy/tfordy-scalar.jl)|264|862|0|3|0|
|63|[ramsey](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ramsey.html)|NLP|Savings Model by Ramsey|[mod](ramsey/ramsey-scalar.mod) [gms](ramsey/ramsey-scalar.gms) [py](ramsey/ramsey-scalar.py) [jl](ramsey/ramsey-scalar.jl)|23|34|0|77|22|
|64|[abel](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_abel.html)|NLP|Linear Quadratic Control Problem|[mod](abel/abel-scalar.mod) [gms](abel/abel-scalar.gms) [py](abel/abel-scalar.py) [jl](abel/abel-scalar.jl)|15|31|0|101|30|
|66|[msm](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_msm.html)|LP|Morocco Fertilizer Distribution - Mode Selection|[mod](msm/msm-scalar.mod) [gms](msm/msm-scalar.gms) [py](msm/msm-scalar.py) [jl](msm/msm-scalar.jl)|761|2|0|7|0|
|68|[water](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_water.html)|DNLP|Design of a Water Distribution Network|[mod](water/water-scalar.mod) [gms](water/water-scalar.gms) [py](water/water-scalar.py) [jl](water/water-scalar.jl)|26|42|0|113|46|
|69|[hhfair](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_hhfair.html)|NLP|Household Optimization Problem by Fair|[mod](hhfair/hhfair-scalar.mod) [gms](hhfair/hhfair-scalar.gms) [py](hhfair/hhfair-scalar.py) [jl](hhfair/hhfair-scalar.jl)|26|30|0|81|21|
|74|[ampl](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ampl.html)|LP|AMPL Sample Problem|[mod](ampl/ampl-scalar.mod) [gms](ampl/ampl-scalar.gms) [py](ampl/ampl-scalar.py) [jl](ampl/ampl-scalar.jl)|13|23|0|75|0|
|75|[egypt](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_egypt.html)|LP|Egypt Agricultural Model|[mod](egypt/egypt-scalar.mod) [gms](egypt/egypt-scalar.gms) [py](egypt/egypt-scalar.py) [jl](egypt/egypt-scalar.jl)|281|618|0|3|0|
|76|[wall](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_wall.html)|NLP|Chemical Equilibrium Problem|[mod](wall/wall-scalar.mod) [gms](wall/wall-scalar.gms) [py](wall/wall-scalar.py) [jl](wall/wall-scalar.jl)|6|6|0|20|10|
|77|[sambal](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_sambal.html)|NLP|Social Accounting Matrix Balancing Problem|[mod](sambal/sambal-scalar.mod) [gms](sambal/sambal-scalar.gms) [py](sambal/sambal-scalar.py) [jl](sambal/sambal-scalar.jl)|11|18|0|48|13|
|78|[phosdis](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_phosdis.html)|LP|Sea Distances for World Phosphate Model|[mod](phosdis/phosdis-scalar.mod) [gms](phosdis/phosdis-scalar.gms) [py](phosdis/phosdis-scalar.py) [jl](phosdis/phosdis-scalar.jl)|305|2|0|8|0|
|79|[ibm1](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ibm1.html)|LP|Aluminum Alloy Smelter Sample Problem|[mod](ibm1/ibm1-scalar.mod) [gms](ibm1/ibm1-scalar.gms) [py](ibm1/ibm1-scalar.py) [jl](ibm1/ibm1-scalar.jl)|8|14|0|55|0|
|80|[etamac](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_etamac.html)|NLP|ETA-MACRO Energy Model for the USA|[mod](etamac/etamac-scalar.mod) [gms](etamac/etamac-scalar.gms) [py](etamac/etamac-scalar.py) [jl](etamac/etamac-scalar.jl)|71|98|0|226|35|
|81|[camcge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_camcge.html)|NLP|Cameroon General Equilibrium Model Using NLP|[mod](camcge/camcge-scalar.mod) [gms](camcge/camcge-scalar.gms) [py](camcge/camcge-scalar.py) [jl](camcge/camcge-scalar.jl)|243|280|0|1|850|
|82|[markov](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_markov.html)|LP|Strategic Petroleum Reserve|[mod](markov/markov-scalar.mod) [gms](markov/markov-scalar.gms) [py](markov/markov-scalar.py) [jl](markov/markov-scalar.jl)|73|129|0|553|0|
|83|[rbrock](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_rbrock.html)|NLP|Rosenbrock Test Function|[mod](rbrock/rbrock-scalar.mod) [gms](rbrock/rbrock-scalar.gms) [py](rbrock/rbrock-scalar.py) [jl](rbrock/rbrock-scalar.jl)|1|3|0|3|2|
|84|[mhw4d](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mhw4d.html)|NLP|Nonlinear Test Problem|[mod](mhw4d/mhw4d-scalar.mod) [gms](mhw4d/mhw4d-scalar.gms) [py](mhw4d/mhw4d-scalar.py) [jl](mhw4d/mhw4d-scalar.jl)|4|6|0|14|10|
|85|[harker](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_harker.html)|NLP|Models of Spatial Competition|[mod](harker/harker-scalar.mod) [gms](harker/harker-scalar.gms) [py](harker/harker-scalar.py) [jl](harker/harker-scalar.jl)|8|21|0|61|20|
|86|[turkey](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_turkey.html)|NLP|Turkey Agricultural Model with Risk|[mod](turkey/turkey-scalar.mod) [gms](turkey/turkey-scalar.gms) [py](turkey/turkey-scalar.py) [jl](turkey/turkey-scalar.jl)|288|519|0|4|55|
|87|[nebrazil](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_nebrazil.html)|LP|North-East Brazil Regional Agricultural Model|[mod](nebrazil/nebrazil-scalar.mod) [gms](nebrazil/nebrazil-scalar.gms) [py](nebrazil/nebrazil-scalar.py) [jl](nebrazil/nebrazil-scalar.jl)|185|414|0|2|0|
|88|[agreste](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_agreste.html)|LP|Agricultural Farm Level Model of NE Brazil|[mod](agreste/agreste-scalar.mod) [gms](agreste/agreste-scalar.gms) [py](agreste/agreste-scalar.py) [jl](agreste/agreste-scalar.jl)|52|101|0|665|0|
|89|[iswnm](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_iswnm.html)|LP|Indus Surface Water Network Submodule|[mod](iswnm/iswnm-scalar.mod) [gms](iswnm/iswnm-scalar.gms) [py](iswnm/iswnm-scalar.py) [jl](iswnm/iswnm-scalar.jl)|457|1|0|1|0|
|90|[indus](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_indus.html)|LP|Indus Agricultural Model|[mod](indus/indus-scalar.mod) [gms](indus/indus-scalar.gms) [py](indus/indus-scalar.py) [jl](indus/indus-scalar.jl)|275|404|0|4|0|
|91|[demo1](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_demo1.html)|LP|Simple Farm Level Model|[mod](demo1/demo1-scalar.mod) [gms](demo1/demo1-scalar.gms) [py](demo1/demo1-scalar.py) [jl](demo1/demo1-scalar.jl)|41|48|0|184|0|
|92|[demo7](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_demo7.html)|NLP|Nonlinear Simple Agricultural Sector Model|[mod](demo7/demo7-scalar.mod) [gms](demo7/demo7-scalar.gms) [py](demo7/demo7-scalar.py) [jl](demo7/demo7-scalar.jl)|51|64|0|269|12|
|95|[himmel11](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_himmel11.html)|QCP|Himmelblau Test Problem Number 11|[mod](himmel11/himmel11-scalar.mod) [gms](himmel11/himmel11-scalar.gms) [py](himmel11/himmel11-scalar.py) [jl](himmel11/himmel11-scalar.jl)|5|10|0|27|16|
|96|[pollut](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pollut.html)|NLP|Industrial Pollution Control|[mod](pollut/pollut-scalar.mod) [gms](pollut/pollut-scalar.gms) [py](pollut/pollut-scalar.py) [jl](pollut/pollut-scalar.jl)|9|43|0|167|40|
|97|[ganges](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ganges.html)|NLP|Macroeconomic Framework for India|[mod](ganges/ganges-scalar.mod) [gms](ganges/ganges-scalar.gms) [py](ganges/ganges-scalar.py) [jl](ganges/ganges-scalar.jl)|274|357|0|1|817|
|98|[thai](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_thai.html)|MIP|Thai Navy Problem|[mod](thai/thai-scalar.mod) [gms](thai/thai-scalar.gms) [py](thai/thai-scalar.py) [jl](thai/thai-scalar.jl)|31|69|23|205|0|
|99|[house](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_house.html)|NLP|House Plan Design|[mod](house/house-scalar.mod) [gms](house/house-scalar.gms) [py](house/house-scalar.py) [jl](house/house-scalar.jl)|9|9|0|26|9|
|100|[korcge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_korcge.html)|NLP|General Equilibrium Model for Korea - NLP|[mod](korcge/korcge-scalar.mod) [gms](korcge/korcge-scalar.gms) [py](korcge/korcge-scalar.py) [jl](korcge/korcge-scalar.jl)|78|96|0|346|200|
|102|[paperco](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_paperco.html)|LP|Vertically Integrated Company|[mod](paperco/paperco-scalar.mod) [gms](paperco/paperco-scalar.gms) [py](paperco/paperco-scalar.py) [jl](paperco/paperco-scalar.jl)|14|22|0|58|0|
|103|[queens](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_queens.html)|MIP|Maximum Queens Chess Problem|[mod](queens/queens-scalar.mod) [gms](queens/queens-scalar.gms) [py](queens/queens-scalar.py) [jl](queens/queens-scalar.jl)|43|65|64|317|0|
|105|[thaix](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_thaix.html)|MIP|Thai Navy Problem Extended|[mod](thaix/thaix-scalar.mod) [gms](thaix/thaix-scalar.gms) [py](thaix/thaix-scalar.py) [jl](thaix/thaix-scalar.jl)|34|72|23|232|0|
|106|[senstran](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_senstran.html)|LP|Sensitivity analysis using LOOPS|[mod](senstran/senstran-scalar.mod) [gms](senstran/senstran-scalar.gms) [py](senstran/senstran-scalar.py) [jl](senstran/senstran-scalar.jl)|6|7|0|19|0|
|107|[gangesx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gangesx.html)|NLP|Economic Framework for India - Tracking|[mod](gangesx/gangesx-scalar.mod) [gms](gangesx/gangesx-scalar.gms) [py](gangesx/gangesx-scalar.py) [jl](gangesx/gangesx-scalar.jl)|274|357|0|1|817|
|108|[sparta](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_sparta.html)|LP|Military Manpower Planning from Wagner|[mod](sparta/sparta-scalar.mod) [gms](sparta/sparta-scalar.gms) [py](sparta/sparta-scalar.py) [jl](sparta/sparta-scalar.jl)|11|41|0|131|0|
|109|[prodschx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_prodschx.html)|MIP|Production Scheduling Model using SOS1 and SOS2|[mod](prodschx/prodschx-scalar.mod) [gms](prodschx/prodschx-scalar.gms) [py](prodschx/prodschx-scalar.py) [jl](prodschx/prodschx-scalar.jl)|89|118|41|384|0|
|110|[immun](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_immun.html)|QCP|Financial Optimization: Risk Management|[mod](immun/immun-scalar.mod) [gms](immun/immun-scalar.gms) [py](immun/immun-scalar.py) [jl](immun/immun-scalar.jl)|3|9|0|25|7|
|111|[worst](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_worst.html)|NLP|Financial Optimization: Risk Management|[mod](worst/worst-scalar.mod) [gms](worst/worst-scalar.gms) [py](worst/worst-scalar.py) [jl](worst/worst-scalar.jl)|30|35|0|112|53|
|112|[meanvar](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_meanvar.html)|NLP|Financial Optimization: Risk Management|[mod](meanvar/meanvar-scalar.mod) [gms](meanvar/meanvar-scalar.gms) [py](meanvar/meanvar-scalar.py) [jl](meanvar/meanvar-scalar.jl)|3|9|0|23|7|
|113|[meanvarx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_meanvarx.html)|MINLP|Financial Optimization: Risk Management|[mod](meanvarx/meanvarx-scalar.mod) [gms](meanvarx/meanvarx-scalar.gms) [py](meanvarx/meanvarx-scalar.py) [jl](meanvarx/meanvarx-scalar.jl)|45|36|14|111|7|
|114|[cmo](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cmo.html)|MIP|Financial Optimization: Financial Engineering|[mod](cmo/cmo-scalar.mod) [gms](cmo/cmo-scalar.gms) [py](cmo/cmo-scalar.py) [jl](cmo/cmo-scalar.jl)|328|293|56|1|0|
|115|[tba](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tba.html)|MIP|Financial Optimization: Financial Engineering|[mod](tba/tba-scalar.mod) [gms](tba/tba-scalar.gms) [py](tba/tba-scalar.py) [jl](tba/tba-scalar.jl)|487|255|199|1|0|
|116|[procsel](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_procsel.html)|MINLP|Structural Optimization of Process Flowsheets|[mod](procsel/procsel-scalar.mod) [gms](procsel/procsel-scalar.gms) [py](procsel/procsel-scalar.py) [jl](procsel/procsel-scalar.jl)|8|11|3|26|2|
|117|[synheat](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_synheat.html)|MINLP|Simultaneous Optimization for Hen Synthesis|[mod](synheat/synheat-scalar.mod) [gms](synheat/synheat-scalar.gms) [py](synheat/synheat-scalar.py) [jl](synheat/synheat-scalar.jl)|65|57|12|225|32|
|118|[minlphi](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_minlphi.html)|NLP|Heat Integrated Distillation Sequences|[mod](minlphi/minlphi-scalar.mod) [gms](minlphi/minlphi-scalar.gms) [py](minlphi/minlphi-scalar.py) [jl](minlphi/minlphi-scalar.jl)|80|65|20|207|36|
|119|[batchdes](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_batchdes.html)|MINLP|Optimal Design for Chemical Batch Processing|[mod](batchdes/batchdes-scalar.mod) [gms](batchdes/batchdes-scalar.gms) [py](batchdes/batchdes-scalar.py) [jl](batchdes/batchdes-scalar.jl)|20|20|9|53|10|
|120|[nonsharp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_nonsharp.html)|MIP|Synthesis of General Distillation Sequences|[mod](nonsharp/nonsharp-scalar.mod) [gms](nonsharp/nonsharp-scalar.gms) [py](nonsharp/nonsharp-scalar.py) [jl](nonsharp/nonsharp-scalar.jl)|41|51|2|160|88|
|121|[reaction](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_reaction.html)|MIP|Logical Inference for Reaction path synthesis|[mod](reaction/reaction-scalar.mod) [gms](reaction/reaction-scalar.gms) [py](reaction/reaction-scalar.py) [jl](reaction/reaction-scalar.jl)|23|35|19|79|0|
|122|[feedtray](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_feedtray.html)|MINLP|Optimum Feed Plate Location|[mod](feedtray/feedtray-scalar.mod) [gms](feedtray/feedtray-scalar.gms) [py](feedtray/feedtray-scalar.py) [jl](feedtray/feedtray-scalar.jl)|92|98|7|451|282|
|123|[hda](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_hda.html)|MINLP|Synthesis: Hydrodealkylation of Toluene|[mod](hda/hda-scalar.mod) [gms](hda/hda-scalar.gms) [py](hda/hda-scalar.py) [jl](hda/hda-scalar.jl)|719|723|13|2|464|
|125|[waterx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_waterx.html)|MINLP|Design of a Water Distribution Network (MINLP)|[mod](waterx/waterx-scalar.mod) [gms](waterx/waterx-scalar.gms) [py](waterx/waterx-scalar.py) [jl](waterx/waterx-scalar.jl)|55|71|14|241|60|
|126|[transmcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_transmcp.html)|MCP|Transportation Model as Equilibrium Problem|[mod](transmcp/transmcp-scalar.mod) [gms](transmcp/transmcp-scalar.gms) [py](transmcp/transmcp-scalar.py) [jl](transmcp/transmcp-scalar.jl)|11|11|0|24|0|
|127|[wallmcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_wallmcp.html)|MCP|Chemical Equilibrium Problem as MCP|[mod](wallmcp/wallmcp-scalar.mod) [gms](wallmcp/wallmcp-scalar.gms) [py](wallmcp/wallmcp-scalar.py) [jl](wallmcp/wallmcp-scalar.jl)|6|6|0|20|10|
|128|[harkmcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_harkmcp.html)|MCP|Models of Spatial Competition in MCP Form|[mod](harkmcp/harkmcp-scalar.mod) [gms](harkmcp/harkmcp-scalar.gms) [py](harkmcp/harkmcp-scalar.py) [jl](harkmcp/harkmcp-scalar.jl)|32|32|0|100|14|
|129|[cammcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cammcp.html)|MCP|Cameroon General Equilibrium Model Using MCP|[mod](cammcp/cammcp-scalar.mod) [gms](cammcp/cammcp-scalar.gms) [py](cammcp/cammcp-scalar.py) [jl](cammcp/cammcp-scalar.jl)|243|280|0|1|908|
|130|[kormcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_kormcp.html)|MCP|General Equilibrium Model for Korea - MCP|[mod](kormcp/kormcp-scalar.mod) [gms](kormcp/kormcp-scalar.gms) [py](kormcp/kormcp-scalar.py) [jl](kormcp/kormcp-scalar.jl)|78|96|0|346|200|
|131|[two3mcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_two3mcp.html)|MCP|Simple 2 x 2 x 2 General Equilibrium Model|[mod](two3mcp/two3mcp-scalar.mod) [gms](two3mcp/two3mcp-scalar.gms) [py](two3mcp/two3mcp-scalar.py) [jl](two3mcp/two3mcp-scalar.jl)|8|8|0|28|20|
|132|[scarfmcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_scarfmcp.html)|MCP|Scarf's Activity Analysis Example|[mod](scarfmcp/scarfmcp-scalar.mod) [gms](scarfmcp/scarfmcp-scalar.gms) [py](scarfmcp/scarfmcp-scalar.py) [jl](scarfmcp/scarfmcp-scalar.jl)|19|19|0|138|43|
|133|[oligomcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_oligomcp.html)|MCP|Oligopolistic Competition - Examples from MP|[mod](oligomcp/oligomcp-scalar.mod) [gms](oligomcp/oligomcp-scalar.gms) [py](oligomcp/oligomcp-scalar.py) [jl](oligomcp/oligomcp-scalar.jl)|6|6|0|16|11|
|134|[mr5mcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mr5mcp.html)|MCP|Multi-Region Growth Model Based on Global 2100|[mod](mr5mcp/mr5mcp-scalar.mod) [gms](mr5mcp/mr5mcp-scalar.gms) [py](mr5mcp/mr5mcp-scalar.py) [jl](mr5mcp/mr5mcp-scalar.jl)|351|361|0|1|561|
|135|[hansmcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_hansmcp.html)|MCP|Hansen's Activity Analysis Example - MCP|[mod](hansmcp/hansmcp-scalar.mod) [gms](hansmcp/hansmcp-scalar.gms) [py](hansmcp/hansmcp-scalar.py) [jl](hansmcp/hansmcp-scalar.jl)|44|44|0|367|33|
|136|[vonthmcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_vonthmcp.html)|MCP|General Equilibrium Variant of the von Thunen Model|[mod](vonthmcp/vonthmcp-scalar.mod) [gms](vonthmcp/vonthmcp-scalar.gms) [py](vonthmcp/vonthmcp-scalar.py) [jl](vonthmcp/vonthmcp-scalar.jl)|126|126|0|733|448|
|137|[gemmcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gemmcp.html)|MCP|GEMTAP: A general equilibrium model for tax policy|[mod](gemmcp/gemmcp-scalar.mod) [gms](gemmcp/gemmcp-scalar.gms) [py](gemmcp/gemmcp-scalar.py) [jl](gemmcp/gemmcp-scalar.jl)|264|267|0|2|1|
|138|[ers82mcp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ers82mcp.html)|MCP|USDA-ERS CGE Model of the US|[mod](ers82mcp/ers82mcp-scalar.mod) [gms](ers82mcp/ers82mcp-scalar.gms) [py](ers82mcp/ers82mcp-scalar.py) [jl](ers82mcp/ers82mcp-scalar.jl)|232|260|0|1|624|
|159|[latin](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_latin.html)|MIP|The Orthogonal Latin-Square Problem|[mod](latin/latin-scalar.mod) [gms](latin/latin-scalar.gms) [py](latin/latin-scalar.py) [jl](latin/latin-scalar.jl)|161|129|127|641|0|
|160|[icut](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_icut.html)|MIP|Integer Cut Example|[mod](icut/icut-scalar.mod) [gms](icut/icut-scalar.gms) [py](icut/icut-scalar.py) [jl](icut/icut-scalar.jl)|2|5|3|8|0|
|161|[launch](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_launch.html)|NLP|Launch Vehicle Design and Costing|[mod](launch/launch-scalar.mod) [gms](launch/launch-scalar.gms) [py](launch/launch-scalar.py) [jl](launch/launch-scalar.jl)|29|39|0|108|52|
|163|[bidsos](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_bidsos.html)|MIP|Bid Evaluation with SOS2 Sets|[mod](bidsos/bidsos-scalar.mod) [gms](bidsos/bidsos-scalar.gms) [py](bidsos/bidsos-scalar.py) [jl](bidsos/bidsos-scalar.jl)|7|20|0|42|0|
|164|[decomp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_decomp.html)|LP|Decomposition Principle - Animated|[mod](decomp/decomp-scalar.mod) [gms](decomp/decomp-scalar.gms) [py](decomp/decomp-scalar.py) [jl](decomp/decomp-scalar.jl)|9|11|0|30|0|
|165|[alkyl](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_alkyl.html)|NLP|Simplified Alkylation Process|[mod](alkyl/alkyl-scalar.mod) [gms](alkyl/alkyl-scalar.gms) [py](alkyl/alkyl-scalar.py) [jl](alkyl/alkyl-scalar.jl)|8|15|0|32|19|
|166|[dispatch](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_dispatch.html)|NLP|Economic Load Dispatch Including Transmission Losses|[mod](dispatch/dispatch-scalar.mod) [gms](dispatch/dispatch-scalar.gms) [py](dispatch/dispatch-scalar.py) [jl](dispatch/dispatch-scalar.jl)|3|5|0|12|6|
|167|[hydro](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_hydro.html)|NLP|Hydrothermal Scheduling Problem|[mod](hydro/hydro-scalar.mod) [gms](hydro/hydro-scalar.gms) [py](hydro/hydro-scalar.py) [jl](hydro/hydro-scalar.jl)|25|32|0|67|12|
|168|[fuel](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_fuel.html)|MINLP|Fuel Scheduling and Unit Commitment Problem|[mod](fuel/fuel-scalar.mod) [gms](fuel/fuel-scalar.gms) [py](fuel/fuel-scalar.py) [jl](fuel/fuel-scalar.jl)|16|16|3|39|6|
|169|[traffic](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_traffic.html)|MCP|Traffic Equilibrium Problem|[mod](traffic/traffic-scalar.mod) [gms](traffic/traffic-scalar.gms) [py](traffic/traffic-scalar.py) [jl](traffic/traffic-scalar.jl)|2|2|0|10|76|
|170|[alphamet](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_alphamet.html)|MIP|Alphametics - a Mathematical Puzzle|[mod](alphamet/alphamet-scalar.mod) [gms](alphamet/alphamet-scalar.gms) [py](alphamet/alphamet-scalar.py) [jl](alphamet/alphamet-scalar.jl)|42|118|107|346|0|
|171|[qp1](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp1.html)|NLP|Standard QP Model|[mod](qp1/qp1-scalar.mod) [gms](qp1/qp1-scalar.gms) [py](qp1/qp1-scalar.py) [jl](qp1/qp1-scalar.jl)|3|51|0|148|50|
|172|[qp2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp2.html)|NLP|Standard QP Model - symmetry exploitations|[mod](qp2/qp2-scalar.mod) [gms](qp2/qp2-scalar.gms) [py](qp2/qp2-scalar.py) [jl](qp2/qp2-scalar.jl)|3|51|0|148|50|
|173|[qp3](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp3.html)|NLP|Standard QP Model - intermediate variables|[mod](qp3/qp3-scalar.mod) [gms](qp3/qp3-scalar.gms) [py](qp3/qp3-scalar.py) [jl](qp3/qp3-scalar.jl)|53|101|0|2|100|
|174|[qp4](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp4.html)|NLP|Standard QP Model - no covariance matrix|[mod](qp4/qp4-scalar.mod) [gms](qp4/qp4-scalar.gms) [py](qp4/qp4-scalar.py) [jl](qp4/qp4-scalar.jl)|32|80|0|1|29|
|175|[qp5](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp5.html)|LP|Standard QP Model - linear approximation|[mod](qp5/qp5-scalar.mod) [gms](qp5/qp5-scalar.gms) [py](qp5/qp5-scalar.py) [jl](qp5/qp5-scalar.jl)|32|109|0|1|0|
|176|[dice](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_dice.html)|MIP|Non-transitive Dice Design|[mod](dice/dice-scalar.mod) [gms](dice/dice-scalar.gms) [py](dice/dice-scalar.py) [jl](dice/dice-scalar.jl)|126|127|108|465|0|
|177|[tsp1](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tsp1.html)|MIP|Traveling Salesman Problem - One|[mod](tsp1/tsp1-scalar.mod) [gms](tsp1/tsp1-scalar.gms) [py](tsp1/tsp1-scalar.py) [jl](tsp1/tsp1-scalar.jl)|13|37|30|101|0|
|178|[tsp2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tsp2.html)|MIP|Traveling Salesman Problem - Two|[mod](tsp2/tsp2-scalar.mod) [gms](tsp2/tsp2-scalar.gms) [py](tsp2/tsp2-scalar.py) [jl](tsp2/tsp2-scalar.jl)|38|42|30|166|0|
|179|[tsp3](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tsp3.html)|MIP|Traveling Salesman Problem - Three|[mod](tsp3/tsp3-scalar.mod) [gms](tsp3/tsp3-scalar.gms) [py](tsp3/tsp3-scalar.py) [jl](tsp3/tsp3-scalar.jl)|75|37|30|737|0|
|181|[indus89](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_indus89.html)|LP|Indus Basin Water Resource Model|[mod](indus89/indus89-scalar.mod) [gms](indus89/indus89-scalar.gms) [py](indus89/indus89-scalar.py) [jl](indus89/indus89-scalar.jl)|2|6|0|39|0|
|184|[qp6](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp6.html)|MCP|Standard QP Model - LCP formulation of QP4|[mod](qp6/qp6-scalar.mod) [gms](qp6/qp6-scalar.gms) [py](qp6/qp6-scalar.py) [jl](qp6/qp6-scalar.jl)|110|110|0|3|0|
|185|[rotdk](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_rotdk.html)|MIP|Robust Optimization|[mod](rotdk/rotdk-scalar.mod) [gms](rotdk/rotdk-scalar.gms) [py](rotdk/rotdk-scalar.py) [jl](rotdk/rotdk-scalar.jl)|12|1|120|25|0|
|186|[prodsp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_prodsp.html)|LP|Stochastic Programming Example|[mod](prodsp/prodsp-scalar.mod) [gms](prodsp/prodsp-scalar.gms) [py](prodsp/prodsp-scalar.py) [jl](prodsp/prodsp-scalar.jl)|0|0|0|0|0|
|187|[kand](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_kand.html)|LP|Stochastic Programming|[mod](kand/kand-scalar.mod) [gms](kand/kand-scalar.gms) [py](kand/kand-scalar.py) [jl](kand/kand-scalar.jl)|26|29|0|105|0|
|188|[lands](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lands.html)|LP|Optimal Investment|[mod](lands/lands-scalar.mod) [gms](lands/lands-scalar.gms) [py](lands/lands-scalar.py) [jl](lands/lands-scalar.jl)|10|17|0|53|0|
|189|[airsp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_airsp.html)|LP|Aircraft Allocation|[mod](airsp/airsp-scalar.mod) [gms](airsp/airsp-scalar.gms) [py](airsp/airsp-scalar.py) [jl](airsp/airsp-scalar.jl)|36|49|0|129|0|
|191|[cross](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cross.html)|MIP|Alcuin's River Crossing|[mod](cross/cross-scalar.mod) [gms](cross/cross-scalar.gms) [py](cross/cross-scalar.py) [jl](cross/cross-scalar.jl)|87|68|27|239|0|
|193|[marilyn](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_marilyn.html)|MIP|Numerical Puzzle|[mod](marilyn/marilyn-scalar.mod) [gms](marilyn/marilyn-scalar.gms) [py](marilyn/marilyn-scalar.py) [jl](marilyn/marilyn-scalar.jl)|127|107|106|481|0|
|194|[nemhaus](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_nemhaus.html)|MIP|Scheduling to Minimize Interaction Cost|[mod](nemhaus/nemhaus-scalar.mod) [gms](nemhaus/nemhaus-scalar.gms) [py](nemhaus/nemhaus-scalar.py) [jl](nemhaus/nemhaus-scalar.jl)|6|6|5|11|5|
|196|[airsp2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_airsp2.html)|LP|Aircraft Allocation - stochastic optimization with DECIS|[mod](airsp2/airsp2-scalar.mod) [gms](airsp2/airsp2-scalar.gms) [py](airsp2/airsp2-scalar.py) [jl](airsp2/airsp2-scalar.jl)|10|26|0|65|0|
|199|[farm](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_farm.html)|LP|The Farmer's Problem formulated for DECIS|[mod](farm/farm-scalar.mod) [gms](farm/farm-scalar.gms) [py](farm/farm-scalar.py) [jl](farm/farm-scalar.jl)|8|13|0|28|0|
|200|[prodsp2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_prodsp2.html)|LP|Stochastic Programming Example - reformulated for DECIS|[mod](prodsp2/prodsp2-scalar.mod) [gms](prodsp2/prodsp2-scalar.gms) [py](prodsp2/prodsp2-scalar.py) [jl](prodsp2/prodsp2-scalar.jl)|4|7|0|21|0|
|202|[bearing](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_bearing.html)|NLP|Hydrostatic Thrust Bearing Design for a Turbogenerator|[mod](bearing/bearing-scalar.mod) [gms](bearing/bearing-scalar.gms) [py](bearing/bearing-scalar.py) [jl](bearing/bearing-scalar.jl)|13|14|0|41|28|
|203|[gear](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gear.html)|MINLP|Gear Train Design|[mod](gear/gear-scalar.mod) [gms](gear/gear-scalar.gms) [py](gear/gear-scalar.py) [jl](gear/gear-scalar.jl)|3|5|4|9|4|
|204|[trimloss](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_trimloss.html)|MINLP|Trim Loss Minimization|[mod](trimloss/trimloss-scalar.mod) [gms](trimloss/trimloss-scalar.gms) [py](trimloss/trimloss-scalar.py) [jl](trimloss/trimloss-scalar.jl)|54|49|48|303|72|
|205|[pump](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pump.html)|MINLP|Pump Network Synthesis|[mod](pump/pump-scalar.mod) [gms](pump/pump-scalar.gms) [py](pump/pump-scalar.py) [jl](pump/pump-scalar.jl)|35|25|9|94|36|
|206|[spring](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_spring.html)|MINLP|Coil Compression String Design|[mod](spring/spring-scalar.mod) [gms](spring/spring-scalar.gms) [py](spring/spring-scalar.py) [jl](spring/spring-scalar.jl)|9|18|12|44|14|
|207|[mrp2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mrp2.html)|MIP|Materials Requirement Planning (MRP) Formulations|[mod](mrp2/mrp2-scalar.mod) [gms](mrp2/mrp2-scalar.gms) [py](mrp2/mrp2-scalar.py) [jl](mrp2/mrp2-scalar.jl)|119|81|40|419|0|
|208|[absmip](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_absmip.html)|MIP|Discontinous functions abs() min() max() sign() as MIPs|[mod](absmip/absmip-scalar.mod) [gms](absmip/absmip-scalar.gms) [py](absmip/absmip-scalar.py) [jl](absmip/absmip-scalar.jl)|4|5|1|10|0|
|209|[camcns](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_camcns.html)|CNS|Cameroon General Equilibrium Model Using CNS|[mod](camcns/camcns-scalar.mod) [gms](camcns/camcns-scalar.gms) [py](camcns/camcns-scalar.py) [jl](camcns/camcns-scalar.jl)|243|280|0|1|850|
|210|[gancns](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gancns.html)|CNS|Macro-Economic Framework for India - CNS|[mod](gancns/gancns-scalar.mod) [gms](gancns/gancns-scalar.gms) [py](gancns/gancns-scalar.py) [jl](gancns/gancns-scalar.jl)|274|357|0|1|817|
|211|[gancnsx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gancnsx.html)|CNS|Macro-Economic Framework for India - Tracking CNS|[mod](gancnsx/gancnsx-scalar.mod) [gms](gancnsx/gancnsx-scalar.gms) [py](gancnsx/gancnsx-scalar.py) [jl](gancnsx/gancnsx-scalar.jl)|274|357|0|1|817|
|212|[korcns](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_korcns.html)|CNS|General Equilibrium Model for Korea - CNS|[mod](korcns/korcns-scalar.mod) [gms](korcns/korcns-scalar.gms) [py](korcns/korcns-scalar.py) [jl](korcns/korcns-scalar.jl)|78|96|0|346|200|
|213|[tsp42](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tsp42.html)|MIP|TSP solution with subtour elimination|[mod](tsp42/tsp42-scalar.mod) [gms](tsp42/tsp42-scalar.gms) [py](tsp42/tsp42-scalar.py) [jl](tsp42/tsp42-scalar.jl)|43|862|861|2|0|
|214|[haverly](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_haverly.html)|NLP|Haverly's pooling problem example|[mod](haverly/haverly-scalar.mod) [gms](haverly/haverly-scalar.gms) [py](haverly/haverly-scalar.py) [jl](haverly/haverly-scalar.jl)|10|13|0|34|7|
|217|[gastrans](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gastrans.html)|NLP|Gas Transmission Problem - Belgium|[mod](gastrans/gastrans-scalar.mod) [gms](gastrans/gastrans-scalar.gms) [py](gastrans/gastrans-scalar.py) [jl](gastrans/gastrans-scalar.jl)|45|65|0|146|24|
|218|[coexx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_coexx.html)|MIP|Peacefully Coexisting Armies of Queens - tight|[mod](coexx/coexx-scalar.mod) [gms](coexx/coexx-scalar.gms) [py](coexx/coexx-scalar.py) [jl](coexx/coexx-scalar.jl)|242|75|73|484|0|
|219|[coex](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_coex.html)|MIP|Peacefully Coexisting Armies of Queens|[mod](coex/coex-scalar.mod) [gms](coex/coex-scalar.gms) [py](coex/coex-scalar.py) [jl](coex/coex-scalar.jl)|1|129|128|3|0|
|220|[railcirc](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_railcirc.html)|MIP|Minimum Circulation of Railway Stock|[mod](railcirc/railcirc-scalar.mod) [gms](railcirc/railcirc-scalar.gms) [py](railcirc/railcirc-scalar.py) [jl](railcirc/railcirc-scalar.jl)|496|298|297|896|0|
|221|[lop](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lop.html)|MIP|Line Optimization|[mod](lop/lop-scalar.mod) [gms](lop/lop-scalar.gms) [py](lop/lop-scalar.py) [jl](lop/lop-scalar.jl)|530|1|253|4|0|
|222|[csched](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_csched.html)|MINLP|Cyclic Scheduling of Continuous Parallel Units|[mod](csched/csched-scalar.mod) [gms](csched/csched-scalar.gms) [py](csched/csched-scalar.py) [jl](csched/csched-scalar.jl)|23|77|63|174|8|
|223|[gasnet](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gasnet.html)|MINLP|Optimal Design of a Gas Transmission Network|[mod](gasnet/gasnet-scalar.mod) [gms](gasnet/gasnet-scalar.gms) [py](gasnet/gasnet-scalar.py) [jl](gasnet/gasnet-scalar.jl)|70|91|10|267|130|
|224|[windfac](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_windfac.html)|MINLP|Winding Factor of Electrical Machines|[mod](windfac/windfac-scalar.mod) [gms](windfac/windfac-scalar.gms) [py](windfac/windfac-scalar.py) [jl](windfac/windfac-scalar.jl)|14|15|3|38|24|
|225|[stockcc](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_stockcc.html)|MIP|Minimizing Total Average Cycle Stock|[mod](stockcc/stockcc-scalar.mod) [gms](stockcc/stockcc-scalar.gms) [py](stockcc/stockcc-scalar.py) [jl](stockcc/stockcc-scalar.jl)|98|481|432|1|0|
|226|[nsharpx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_nsharpx.html)|MINLP|Synthesis of General Distillation Sequences|[mod](nsharpx/nsharpx-scalar.mod) [gms](nsharpx/nsharpx-scalar.gms) [py](nsharpx/nsharpx-scalar.py) [jl](nsharpx/nsharpx-scalar.jl)|44|51|2|197|122|
|227|[minlphix](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_minlphix.html)|MINLP|Heat Integrated Distillation Sequences|[mod](minlphix/minlphix-scalar.mod) [gms](minlphix/minlphix-scalar.gms) [py](minlphix/minlphix-scalar.py) [jl](minlphix/minlphix-scalar.jl)|101|85|20|337|40|
|228|[cesam](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cesam.html)|MCP|Cross Entropy SAM Estimation|[mod](cesam/cesam-scalar.mod) [gms](cesam/cesam-scalar.gms) [py](cesam/cesam-scalar.py) [jl](cesam/cesam-scalar.jl)|78|130|0|368|136|
|229|[polygon](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_polygon.html)|NLP|Largest small polygon COPS 2.0 #1|[mod](polygon/polygon-scalar.mod) [gms](polygon/polygon-scalar.gms) [py](polygon/polygon-scalar.py) [jl](polygon/polygon-scalar.jl)|325|51|0|1|1|
|230|[elec](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_elec.html)|NLP|Distribution of electrons on a sphere COPS 2.0 #2|[mod](elec/elec-scalar.mod) [gms](elec/elec-scalar.gms) [py](elec/elec-scalar.py) [jl](elec/elec-scalar.jl)|26|76|0|151|150|
|231|[chain](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_chain.html)|NLP|Hanging Chain COPS 2.0 #3|[mod](chain/chain-scalar.mod) [gms](chain/chain-scalar.gms) [py](chain/chain-scalar.py) [jl](chain/chain-scalar.jl)|52|103|0|354|153|
|232|[camshape](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_camshape.html)|NLP|Shape optimization of a cam COPS 2.0 #4|[mod](camshape/camshape-scalar.mod) [gms](camshape/camshape-scalar.gms) [py](camshape/camshape-scalar.py) [jl](camshape/camshape-scalar.jl)|201|200|0|697|299|
|233|[pinene](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pinene.html)|NLP|Isometrization of alpha-pinene COPS 2.0 #5|[mod](pinene/pinene-scalar.mod) [gms](pinene/pinene-scalar.gms) [py](pinene/pinene-scalar.py) [jl](pinene/pinene-scalar.jl)|2|2|0|11|2|
|234|[popdynm](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_popdynm.html)|NLP|Marine population dynamics COPS 2.0 #6|[mod](popdynm/popdynm-scalar.mod) [gms](popdynm/popdynm-scalar.gms) [py](popdynm/popdynm-scalar.py) [jl](popdynm/popdynm-scalar.jl)|1|1|0|6|2|
|235|[flowchan](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_flowchan.html)|NLP|Flow in a channel COPS 2.0 #7|[mod](flowchan/flowchan-scalar.mod) [gms](flowchan/flowchan-scalar.gms) [py](flowchan/flowchan-scalar.py) [jl](flowchan/flowchan-scalar.jl)|1|1|0|9|800|
|236|[robot](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_robot.html)|NLP|Robot arm COPS 2.0 #8|[mod](robot/robot-scalar.mod) [gms](robot/robot-scalar.gms) [py](robot/robot-scalar.py) [jl](robot/robot-scalar.jl)|403|563|0|1|1|
|237|[lnts](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lnts.html)|NLP|Particle steering COPS 2.0 #9|[mod](lnts/lnts-scalar.mod) [gms](lnts/lnts-scalar.gms) [py](lnts/lnts-scalar.py) [jl](lnts/lnts-scalar.jl)|201|257|0|1|600|
|238|[rocket](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_rocket.html)|NLP|Goddard rocket COPS 2.0 #10|[mod](rocket/rocket-scalar.mod) [gms](rocket/rocket-scalar.gms) [py](rocket/rocket-scalar.py) [jl](rocket/rocket-scalar.jl)|253|308|0|1|903|
|239|[glider](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_glider.html)|NLP|Hang glider COPS 2.0 #11|[mod](glider/glider-scalar.mod) [gms](glider/glider-scalar.gms) [py](glider/glider-scalar.py) [jl](glider/glider-scalar.jl)|610|666|0|2|1|
|240|[gasoil](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gasoil.html)|NLP|Catalytic cracking of gas oil COPS 2.0 #12|[mod](gasoil/gasoil-scalar.mod) [gms](gasoil/gasoil-scalar.gms) [py](gasoil/gasoil-scalar.py) [jl](gasoil/gasoil-scalar.jl)|1|1|0|6|1|
|241|[methanol](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_methanol.html)|NLP|Methanol to hydrocarbons COPS 2.0 #13|[mod](methanol/methanol-scalar.mod) [gms](methanol/methanol-scalar.gms) [py](methanol/methanol-scalar.py) [jl](methanol/methanol-scalar.jl)|1|1|0|8|3|
|242|[catmix](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_catmix.html)|NLP|Catalyst Mixing COPS 2.0 #14|[mod](catmix/catmix-scalar.mod) [gms](catmix/catmix-scalar.gms) [py](catmix/catmix-scalar.py) [jl](catmix/catmix-scalar.jl)|201|304|0|1|1|
|243|[torsion](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_torsion.html)|NLP|Elastic-plastic torsion COPS 2.0 #15|[mod](torsion/torsion-scalar.mod) [gms](torsion/torsion-scalar.gms) [py](torsion/torsion-scalar.py) [jl](torsion/torsion-scalar.jl)|5|1|0|5|2|
|244|[jbearing](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_jbearing.html)|NLP|Journal bearing COPS 2.0 #16|[mod](jbearing/jbearing-scalar.mod) [gms](jbearing/jbearing-scalar.gms) [py](jbearing/jbearing-scalar.py) [jl](jbearing/jbearing-scalar.jl)|1|2|0|2|2|
|245|[minsurf](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_minsurf.html)|NLP|Minimal surface with obstacle COPS 2.0 #17|[mod](minsurf/minsurf-scalar.mod) [gms](minsurf/minsurf-scalar.gms) [py](minsurf/minsurf-scalar.py) [jl](minsurf/minsurf-scalar.jl)|1|1|0|1|1|
|246|[qp1x](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp1x.html)|NLP|Standard QP Model with GDX data input|[mod](qp1x/qp1x-scalar.mod) [gms](qp1x/qp1x-scalar.gms) [py](qp1x/qp1x-scalar.py) [jl](qp1x/qp1x-scalar.jl)|3|51|0|148|50|
|247|[tvcsched](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tvcsched.html)|MIP|Flow Formulation of the ISCI Rotator Problem|[mod](tvcsched/tvcsched-scalar.mod) [gms](tvcsched/tvcsched-scalar.gms) [py](tvcsched/tvcsched-scalar.py) [jl](tvcsched/tvcsched-scalar.jl)|189|7|76|23|0|
|248|[srkandw](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_srkandw.html)|LP|Stochastic Programming Scenario Reduction|[mod](srkandw/srkandw-scalar.mod) [gms](srkandw/srkandw-scalar.gms) [py](srkandw/srkandw-scalar.py) [jl](srkandw/srkandw-scalar.jl)|6|9|0|27|0|
|249|[clearlak](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_clearlak.html)|LP|Scenario Reduction: ClearLake exercise|[mod](clearlak/clearlak-scalar.mod) [gms](clearlak/clearlak-scalar.gms) [py](clearlak/clearlak-scalar.py) [jl](clearlak/clearlak-scalar.jl)|23|92|0|157|0|
|250|[jit](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_jit.html)|MINLP|Design of Just-in-Time Flowshops|[mod](jit/jit-scalar.mod) [gms](jit/jit-scalar.gms) [py](jit/jit-scalar.py) [jl](jit/jit-scalar.jl)|33|26|4|112|12|
|251|[lmp1](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lmp1.html)|NLP|Linear Multiplicative Model - Type 1|[mod](lmp1/lmp1-scalar.mod) [gms](lmp1/lmp1-scalar.gms) [py](lmp1/lmp1-scalar.py) [jl](lmp1/lmp1-scalar.jl)|23|33|0|665|2|
|252|[lmp2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lmp2.html)|NLP|Linear Multiplicative Model - Type 2|[mod](lmp2/lmp2-scalar.mod) [gms](lmp2/lmp2-scalar.gms) [py](lmp2/lmp2-scalar.py) [jl](lmp2/lmp2-scalar.jl)|13|23|0|245|2|
|253|[lmp3](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lmp3.html)|NLP|Linear Multiplicative Model - Type 3|[mod](lmp3/lmp3-scalar.mod) [gms](lmp3/lmp3-scalar.gms) [py](lmp3/lmp3-scalar.py) [jl](lmp3/lmp3-scalar.jl)|23|33|0|665|2|
|254|[pool](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pool.html)|NLP|Pooling problem|[mod](pool/pool-scalar.mod) [gms](pool/pool-scalar.gms) [py](pool/pool-scalar.py) [jl](pool/pool-scalar.jl)|20|7|0|61|40|
|255|[mathopt1](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mathopt1.html)|NLP|MathOptimizer Example 1|[mod](mathopt1/mathopt1-scalar.mod) [gms](mathopt1/mathopt1-scalar.gms) [py](mathopt1/mathopt1-scalar.py) [jl](mathopt1/mathopt1-scalar.jl)|3|3|0|7|4|
|256|[mathopt2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mathopt2.html)|NLP|MathOptimizer Example 2|[mod](mathopt2/mathopt2-scalar.mod) [gms](mathopt2/mathopt2-scalar.gms) [py](mathopt2/mathopt2-scalar.py) [jl](mathopt2/mathopt2-scalar.jl)|5|3|0|11|4|
|257|[mathopt3](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mathopt3.html)|NLP|MathOptimizer Example 3|[mod](mathopt3/mathopt3-scalar.mod) [gms](mathopt3/mathopt3-scalar.gms) [py](mathopt3/mathopt3-scalar.py) [jl](mathopt3/mathopt3-scalar.jl)|8|7|0|43|24|
|258|[mathopt4](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mathopt4.html)|NLP|MathOptimizer Example 4|[mod](mathopt4/mathopt4-scalar.mod) [gms](mathopt4/mathopt4-scalar.gms) [py](mathopt4/mathopt4-scalar.py) [jl](mathopt4/mathopt4-scalar.jl)|3|3|0|7|4|
|259|[mathopt5](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mathopt5.html)|DNLP|MathOptimizer Example 5|[mod](mathopt5/mathopt5-scalar.mod) [gms](mathopt5/mathopt5-scalar.gms) [py](mathopt5/mathopt5-scalar.py) [jl](mathopt5/mathopt5-scalar.jl)|1|2|0|2|1|
|260|[mathopt6](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mathopt6.html)|DNLP|MathOptimizer Example 6|[mod](mathopt6/mathopt6-scalar.mod) [gms](mathopt6/mathopt6-scalar.gms) [py](mathopt6/mathopt6-scalar.py) [jl](mathopt6/mathopt6-scalar.jl)|1|3|0|3|2|
|261|[trig](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_trig.html)|NLP|Simple Trigonometric Example|[mod](trig/trig-scalar.mod) [gms](trig/trig-scalar.gms) [py](trig/trig-scalar.py) [jl](trig/trig-scalar.jl)|2|2|0|3|2|
|263|[maxmin](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_maxmin.html)|DNLP|Max Min Location of Points in Unit Square|[mod](maxmin/maxmin-scalar.mod) [gms](maxmin/maxmin-scalar.gms) [py](maxmin/maxmin-scalar.py) [jl](maxmin/maxmin-scalar.jl)|78|27|0|390|312|
|264|[hs62](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_hs62.html)|NLP|Hock - Schittkowski Problem 62|[mod](hs62/hs62-scalar.mod) [gms](hs62/hs62-scalar.gms) [py](hs62/hs62-scalar.py) [jl](hs62/hs62-scalar.jl)|2|4|0|7|6|
|265|[fct](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_fct.html)|DNLP|LGO Interface Example|[mod](fct/fct-scalar.mod) [gms](fct/fct-scalar.gms) [py](fct/fct-scalar.py) [jl](fct/fct-scalar.jl)|10|12|0|43|26|
|266|[t1000](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_t1000.html)|NLP|LGO Test t1000_10|[mod](t1000/t1000-scalar.mod) [gms](t1000/t1000-scalar.gms) [py](t1000/t1000-scalar.py) [jl](t1000/t1000-scalar.jl)|13|1|0|2|2|
|269|[nash](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_nash.html)|MPEC|A non-cooperative game: Nash and Stackelberg versions|[mod](nash/nash-scalar.mod) [gms](nash/nash-scalar.gms) [py](nash/nash-scalar.py) [jl](nash/nash-scalar.jl)|11|11|0|121|120|
|270|[kport](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_kport.html)|MINLP|Product Portfolio Optimization|[mod](kport/kport-scalar.mod) [gms](kport/kport-scalar.gms) [py](kport/kport-scalar.py) [jl](kport/kport-scalar.jl)|28|102|40|190|116|
|271|[qp7](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qp7.html)|QCP|Standard QP Model - conic programming formulation|[mod](qp7/qp7-scalar.mod) [gms](qp7/qp7-scalar.gms) [py](qp7/qp7-scalar.py) [jl](qp7/qp7-scalar.jl)|34|82|0|1|31|
|272|[dicex](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_dicex.html)|MIP|Non-transitive Dice Design - Enhanced|[mod](dicex/dicex-scalar.mod) [gms](dicex/dicex-scalar.gms) [py](dicex/dicex-scalar.py) [jl](dicex/dicex-scalar.jl)|162|451|432|1|0|
|273|[emfl](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_emfl.html)|QCP|Existing Multi Facility Location Problem - Cone Format|[mod](emfl/emfl-scalar.mod) [gms](emfl/emfl-scalar.gms) [py](emfl/emfl-scalar.py) [jl](emfl/emfl-scalar.jl)|16|16|0|41|16|
|274|[hhmax](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_hhmax.html)|NLP|A Household Maximization Problem|[mod](hhmax/hhmax-scalar.mod) [gms](hhmax/hhmax-scalar.gms) [py](hhmax/hhmax-scalar.py) [jl](hhmax/hhmax-scalar.jl)|3|3|0|5|2|
|275|[splcge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_splcge.html)|NLP|A Simple CGE Model|[mod](splcge/splcge-scalar.mod) [gms](splcge/splcge-scalar.gms) [py](splcge/splcge-scalar.py) [jl](splcge/splcge-scalar.jl)|15|15|0|45|24|
|276|[stdcge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_stdcge.html)|NLP|A Standard CGE Model|[mod](stdcge/stdcge-scalar.mod) [gms](stdcge/stdcge-scalar.gms) [py](stdcge/stdcge-scalar.py) [jl](stdcge/stdcge-scalar.jl)|49|49|0|179|90|
|277|[lrgcge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lrgcge.html)|NLP|A Large Country CGE Model|[mod](lrgcge/lrgcge-scalar.mod) [gms](lrgcge/lrgcge-scalar.gms) [py](lrgcge/lrgcge-scalar.py) [jl](lrgcge/lrgcge-scalar.jl)|53|53|0|195|110|
|278|[twocge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_twocge.html)|NLP|A Two Country CGE Model|[mod](twocge/twocge-scalar.mod) [gms](twocge/twocge-scalar.gms) [py](twocge/twocge-scalar.py) [jl](twocge/twocge-scalar.jl)|107|107|0|393|212|
|279|[moncge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_moncge.html)|NLP|A Monopoly CGE Model|[mod](moncge/moncge-scalar.mod) [gms](moncge/moncge-scalar.gms) [py](moncge/moncge-scalar.py) [jl](moncge/moncge-scalar.jl)|51|51|0|193|98|
|280|[quocge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_quocge.html)|NLP|A CGE Model with Quotas|[mod](quocge/quocge-scalar.mod) [gms](quocge/quocge-scalar.gms) [py](quocge/quocge-scalar.py) [jl](quocge/quocge-scalar.jl)|55|53|0|203|106|
|281|[irscge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_irscge.html)|NLP|A CGE Model with Scale Economy|[mod](irscge/irscge-scalar.mod) [gms](irscge/irscge-scalar.gms) [py](irscge/irscge-scalar.py) [jl](irscge/irscge-scalar.jl)|49|49|0|181|92|
|282|[qalan](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qalan.html)|MIQCP|A Quadratic Programming Model for Portfolio Analysis QCP|[mod](qalan/qalan-scalar.mod) [gms](qalan/qalan-scalar.gms) [py](qalan/qalan-scalar.py) [jl](qalan/qalan-scalar.jl)|3|5|4|12|3|
|283|[qcp1](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qcp1.html)|QCP|Standard QP Model QCP|[mod](qcp1/qcp1-scalar.mod) [gms](qcp1/qcp1-scalar.gms) [py](qcp1/qcp1-scalar.py) [jl](qcp1/qcp1-scalar.jl)|3|161|0|453|147|
|284|[qdemo7](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qdemo7.html)|QCP|Nonlinear Simple Agricultural Sector Model QCP|[mod](qdemo7/qdemo7-scalar.mod) [gms](qdemo7/qdemo7-scalar.gms) [py](qdemo7/qdemo7-scalar.py) [jl](qdemo7/qdemo7-scalar.jl)|47|60|0|245|6|
|285|[qsambal](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qsambal.html)|QCP|Social Accounting Matrix Balancing Problem QCP|[mod](qsambal/qsambal-scalar.mod) [gms](qsambal/qsambal-scalar.gms) [py](qsambal/qsambal-scalar.py) [jl](qsambal/qsambal-scalar.jl)|11|18|0|48|13|
|291|[qmeanvar](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qmeanvar.html)|MIQCP|Financial Optimization: Risk Management using MIQCP|[mod](qmeanvar/qmeanvar-scalar.mod) [gms](qmeanvar/qmeanvar-scalar.gms) [py](qmeanvar/qmeanvar-scalar.py) [jl](qmeanvar/qmeanvar-scalar.jl)|45|36|14|111|0|
|293|[qabel](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qabel.html)|QCP|Linear Quadratic Control Problem|[mod](qabel/qabel-scalar.mod) [gms](qabel/qabel-scalar.gms) [py](qabel/qabel-scalar.py) [jl](qabel/qabel-scalar.jl)|149|299|0|1|298|
|294|[cutstock](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cutstock.html)|MIP|Cutting Stock - A Column Generation Approach|[mod](cutstock/cutstock-scalar.mod) [gms](cutstock/cutstock-scalar.gms) [py](cutstock/cutstock-scalar.py) [jl](cutstock/cutstock-scalar.jl)|5|5|4|9|0|
|296|[awkqap](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_awkqap.html)|MIQCP|Input file generation with AWK for the Quadratic Assignment Problem|[mod](awkqap/awkqap-scalar.mod) [gms](awkqap/awkqap-scalar.gms) [py](awkqap/awkqap-scalar.py) [jl](awkqap/awkqap-scalar.jl)|15|50|49|148|49|
|300|[quantum](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_quantum.html)|DNLP|An application from quantum mechanics|[mod](quantum/quantum-scalar.mod) [gms](quantum/quantum-scalar.gms) [py](quantum/quantum-scalar.py) [jl](quantum/quantum-scalar.jl)|1|3|0|3|2|
|301|[procmean](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_procmean.html)|NLP|Optimal Process Mean|[mod](procmean/procmean-scalar.mod) [gms](procmean/procmean-scalar.gms) [py](procmean/procmean-scalar.py) [jl](procmean/procmean-scalar.jl)|2|3|0|5|2|
|302|[mlbeta](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mlbeta.html)|NLP|Fitting of beta distribution through maximum likelihood|[mod](mlbeta/mlbeta-scalar.mod) [gms](mlbeta/mlbeta-scalar.gms) [py](mlbeta/mlbeta-scalar.py) [jl](mlbeta/mlbeta-scalar.jl)|1|3|0|3|2|
|303|[mlgamma](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mlgamma.html)|NLP|Maximum Likelihood estimation of parameters of the gamma distribution|[mod](mlgamma/mlgamma-scalar.mod) [gms](mlgamma/mlgamma-scalar.gms) [py](mlgamma/mlgamma-scalar.py) [jl](mlgamma/mlgamma-scalar.jl)|1|3|0|3|2|
|306|[csp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_csp.html)|MIP|Closest String Problem|[mod](csp/csp-scalar.mod) [gms](csp/csp-scalar.gms) [py](csp/csp-scalar.py) [jl](csp/csp-scalar.jl)|52|31|24|107|0|
|309|[openpit](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_openpit.html)|MIP|Dynamic open pit mining extraction|[mod](openpit/openpit-scalar.mod) [gms](openpit/openpit-scalar.gms) [py](openpit/openpit-scalar.py) [jl](openpit/openpit-scalar.jl)|3|2|1|12|0|
|312|[lrs](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_lrs.html)|MIP|Linear Recursive Sequence Optimization Model|[mod](lrs/lrs-scalar.mod) [gms](lrs/lrs-scalar.gms) [py](lrs/lrs-scalar.py) [jl](lrs/lrs-scalar.jl)|1|351|48|3|0|
|321|[knp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_knp.html)|NLP|Kissing Number Problem using Variable Neighborhood Search|[mod](knp/knp-scalar.mod) [gms](knp/knp-scalar.gms) [py](knp/knp-scalar.py) [jl](knp/knp-scalar.jl)|300|97|0|2|2|
|323|[netgen](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_netgen.html)|LP|Min Cost Flow with an Instance generated by NETGEN|[mod](netgen/netgen-scalar.mod) [gms](netgen/netgen-scalar.gms) [py](netgen/netgen-scalar.py) [jl](netgen/netgen-scalar.jl)|51|251|0|751|0|
|327|[qmeanvag](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_qmeanvag.html)|MIQCP|Portfolio Modeling with Parallel Solutions|[mod](qmeanvag/qmeanvag-scalar.mod) [gms](qmeanvag/qmeanvag-scalar.gms) [py](qmeanvag/qmeanvag-scalar.py) [jl](qmeanvag/qmeanvag-scalar.jl)|45|36|14|111|0|
|329|[jacobi](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_jacobi.html)|MCP|Asynchronous Jacobi Methods|[mod](jacobi/jacobi-scalar.mod) [gms](jacobi/jacobi-scalar.gms) [py](jacobi/jacobi-scalar.py) [jl](jacobi/jacobi-scalar.jl)|0|0|0|0|0|
|331|[mws](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_mws.html)|MIP|Computation of Horowitz's work-trip mode choice model estimates|[mod](mws/mws-scalar.mod) [gms](mws/mws-scalar.gms) [py](mws/mws-scalar.py) [jl](mws/mws-scalar.jl)|843|848|842|5|0|
|338|[maxcut](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_maxcut.html)|MIP|Goemans/Williamson Randomized Approximation Algorithm for MaxCut|[mod](maxcut/maxcut-scalar.mod) [gms](maxcut/maxcut-scalar.gms) [py](maxcut/maxcut-scalar.py) [jl](maxcut/maxcut-scalar.jl)|3|1|400|10|0|
|339|[gqapsdp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_gqapsdp.html)|RMIQCP|SDP Convexifications of the Generalized Quadratic Assignment Problem|[mod](gqapsdp/gqapsdp-scalar.mod) [gms](gqapsdp/gqapsdp-scalar.gms) [py](gqapsdp/gqapsdp-scalar.py) [jl](gqapsdp/gqapsdp-scalar.jl)|24|113|112|337|112|
|341|[two3mac](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_two3mac.html)|MCP|Simple 2 x 2 x 2 General Equilibrium Model Using Macros|[mod](two3mac/two3mac-scalar.mod) [gms](two3mac/two3mac-scalar.gms) [py](two3mac/two3mac-scalar.py) [jl](two3mac/two3mac-scalar.jl)|6|6|0|24|20|
|342|[poutil](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_poutil.html)|MIP|Portfolio Optimization for Electric Utilities|[mod](poutil/poutil-scalar.mod) [gms](poutil/poutil-scalar.gms) [py](poutil/poutil-scalar.py) [jl](poutil/poutil-scalar.jl)|2|1|773|9|0|
|344|[srpchase](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_srpchase.html)|LP|Scenario Tree Construction Example|[mod](srpchase/srpchase-scalar.mod) [gms](srpchase/srpchase-scalar.gms) [py](srpchase/srpchase-scalar.py) [jl](srpchase/srpchase-scalar.jl)|157|168|0|479|0|
|346|[bilinear](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_bilinear.html)|MINLP|Convexification of bilinear term binary times x|[mod](bilinear/bilinear-scalar.mod) [gms](bilinear/bilinear-scalar.gms) [py](bilinear/bilinear-scalar.py) [jl](bilinear/bilinear-scalar.jl)|64|181|60|481|300|
|350|[tanksize](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tanksize.html)|MINLP|Tank Size Design Problem|[mod](tanksize/tanksize-scalar.mod) [gms](tanksize/tanksize-scalar.gms) [py](tanksize/tanksize-scalar.py) [jl](tanksize/tanksize-scalar.jl)|74|47|5|291|63|
|351|[trnspwl](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_trnspwl.html)|MIP|A Transportation Problem with discretized economies of scale|[mod](trnspwl/trnspwl-scalar.mod) [gms](trnspwl/trnspwl-scalar.gms) [py](trnspwl/trnspwl-scalar.py) [jl](trnspwl/trnspwl-scalar.jl)|6|7|42|19|6|
|352|[food](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_food.html)|MIP|Food Manufacturing Problem - Blending of oils|[mod](food/food-scalar.mod) [gms](food/food-scalar.gms) [py](food/food-scalar.py) [jl](food/food-scalar.jl)|133|127|30|493|0|
|353|[relief](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_relief.html)|MIP|Relief Mission|[mod](relief/relief-scalar.mod) [gms](relief/relief-scalar.gms) [py](relief/relief-scalar.py) [jl](relief/relief-scalar.jl)|122|2|100|6|0|
|354|[spatequ](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_spatequ.html)|MCP|Spatial Equilibrium|[mod](spatequ/spatequ-scalar.mod) [gms](spatequ/spatequ-scalar.gms) [py](spatequ/spatequ-scalar.py) [jl](spatequ/spatequ-scalar.jl)|39|37|0|121|12|
|355|[kqkpsdp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_kqkpsdp.html)|RMIQCP|SDP Convexifications of the Cardinality constraint Quadratic Knapsack Problem|[mod](kqkpsdp/kqkpsdp-scalar.mod) [gms](kqkpsdp/kqkpsdp-scalar.gms) [py](kqkpsdp/kqkpsdp-scalar.py) [jl](kqkpsdp/kqkpsdp-scalar.jl)|3|51|50|151|50|
|356|[prodplan](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_prodplan.html)|MIP|A Production Planning Example|[mod](prodplan/prodplan-scalar.mod) [gms](prodplan/prodplan-scalar.gms) [py](prodplan/prodplan-scalar.py) [jl](prodplan/prodplan-scalar.jl)|17|25|8|64|0|
|358|[ps2_f_s](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps2_f_s.html)|NLP|Parts Supply Problem w/ 2 Types w/o and w/ Asymmetric Information|[mod](ps2_f_s/ps2_f_s-scalar.mod) [gms](ps2_f_s/ps2_f_s-scalar.gms) [py](ps2_f_s/ps2_f_s-scalar.py) [jl](ps2_f_s/ps2_f_s-scalar.jl)|5|7|0|13|2|
|359|[ps2_f](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps2_f.html)|NLP|Parts Supply Problem w/ 2 Types w/o Asymmetric Information|[mod](ps2_f/ps2_f-scalar.mod) [gms](ps2_f/ps2_f-scalar.gms) [py](ps2_f/ps2_f-scalar.py) [jl](ps2_f/ps2_f-scalar.jl)|5|7|0|13|2|
|362|[ps2_s](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps2_s.html)|NLP|Parts Supply Problem w/ 2 Types w/ Asymmetric Information|[mod](ps2_s/ps2_s-scalar.mod) [gms](ps2_s/ps2_s-scalar.gms) [py](ps2_s/ps2_s-scalar.py) [jl](ps2_s/ps2_s-scalar.jl)|7|7|0|21|2|
|363|[ps3_f](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps3_f.html)|NLP|Parts Supply Problem w/ 3 Types w/o Asymmetric Information|[mod](ps3_f/ps3_f-scalar.mod) [gms](ps3_f/ps3_f-scalar.gms) [py](ps3_f/ps3_f-scalar.py) [jl](ps3_f/ps3_f-scalar.jl)|7|10|0|19|3|
|364|[ps3_s](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps3_s.html)|NLP|Parts Supply Problem w/ 3 Types w/ Asymmetric Information|[mod](ps3_s/ps3_s-scalar.mod) [gms](ps3_s/ps3_s-scalar.gms) [py](ps3_s/ps3_s-scalar.py) [jl](ps3_s/ps3_s-scalar.jl)|10|10|0|29|3|
|365|[ps3_s_gic](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps3_s_gic.html)|NLP|Parts Supply Problem w/ 3 Types w/ Global Incentive Comp. Const.|[mod](ps3_s_gic/ps3_s_gic-scalar.mod) [gms](ps3_s_gic/ps3_s_gic-scalar.gms) [py](ps3_s_gic/ps3_s_gic-scalar.py) [jl](ps3_s_gic/ps3_s_gic-scalar.jl)|13|10|0|43|3|
|366|[ps3_s_mn](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps3_s_mn.html)|NLP|Parts Supply Problem w/ 3 Types w/ Monotonicity Constraint|[mod](ps3_s_mn/ps3_s_mn-scalar.mod) [gms](ps3_s_mn/ps3_s_mn-scalar.gms) [py](ps3_s_mn/ps3_s_mn-scalar.py) [jl](ps3_s_mn/ps3_s_mn-scalar.jl)|13|10|0|34|3|
|367|[ps3_s_scp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps3_s_scp.html)|NLP|Parts Supply Problem w/ 3 Types w/o and w/ SCP|[mod](ps3_s_scp/ps3_s_scp-scalar.mod) [gms](ps3_s_scp/ps3_s_scp-scalar.gms) [py](ps3_s_scp/ps3_s_scp-scalar.py) [jl](ps3_s_scp/ps3_s_scp-scalar.jl)|13|10|0|43|3|
|368|[ps10_s](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps10_s.html)|NLP|Parts Supply Problem w/ 10 Types and w/ Asymmetric Information|[mod](ps10_s/ps10_s-scalar.mod) [gms](ps10_s/ps10_s-scalar.gms) [py](ps10_s/ps10_s-scalar.py) [jl](ps10_s/ps10_s-scalar.jl)|31|31|0|99|10|
|369|[ps10_s_mn](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps10_s_mn.html)|NLP|Parts Supply Problem w/ 10 Types w/ Random p(i)|[mod](ps10_s_mn/ps10_s_mn-scalar.mod) [gms](ps10_s_mn/ps10_s_mn-scalar.gms) [py](ps10_s_mn/ps10_s_mn-scalar.py) [jl](ps10_s_mn/ps10_s_mn-scalar.jl)|31|31|0|99|10|
|371|[cubesoln](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cubesoln.html)|MIP|Three-Dimensional Noughts and Crosses Multiple Solutions|[mod](cubesoln/cubesoln-scalar.mod) [gms](cubesoln/cubesoln-scalar.gms) [py](cubesoln/cubesoln-scalar.py) [jl](cubesoln/cubesoln-scalar.jl)|0|0|0|0|0|
|373|[cclinpts](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cclinpts.html)|NLP|Finding Optimal Breakpoints when linearizing a power utility function|[mod](cclinpts/cclinpts-scalar.mod) [gms](cclinpts/cclinpts-scalar.gms) [py](cclinpts/cclinpts-scalar.py) [jl](cclinpts/cclinpts-scalar.jl)|31|61|0|121|90|
|376|[flowshop](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_flowshop.html)|MIP|Flow shop scheduling|[mod](flowshop/flowshop-scalar.mod) [gms](flowshop/flowshop-scalar.gms) [py](flowshop/flowshop-scalar.py) [jl](flowshop/flowshop-scalar.jl)|58|73|36|272|0|
|377|[ps5_s_mn](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_ps5_s_mn.html)|NLP|Parts Supply Problem w/ 5 Types w/ Random p(i)|[mod](ps5_s_mn/ps5_s_mn-scalar.mod) [gms](ps5_s_mn/ps5_s_mn-scalar.gms) [py](ps5_s_mn/ps5_s_mn-scalar.py) [jl](ps5_s_mn/ps5_s_mn-scalar.jl)|16|16|0|49|5|
|378|[iobalance](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_iobalance.html)|NLP|Updating and Projecting Coefficients: The RAS Approach|[mod](iobalance/iobalance-scalar.mod) [gms](iobalance/iobalance-scalar.gms) [py](iobalance/iobalance-scalar.py) [jl](iobalance/iobalance-scalar.jl)|7|10|0|28|9|
|380|[pmeanvar](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pmeanvar.html)|MIQCP|Mean-Variance models with variable upper and lower bounds|[mod](pmeanvar/pmeanvar-scalar.mod) [gms](pmeanvar/pmeanvar-scalar.gms) [py](pmeanvar/pmeanvar-scalar.py) [jl](pmeanvar/pmeanvar-scalar.jl)|23|21|10|71|10|
|383|[saras](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_saras.html)|NLP|South African Regionalised Farm-level Resource Use and Output Supply Response (SARAS) model|[mod](saras/saras-scalar.mod) [gms](saras/saras-scalar.gms) [py](saras/saras-scalar.py) [jl](saras/saras-scalar.jl)|110|100|0|421|36|
|385|[bidpwl](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_bidpwl.html)|MIP|Bid Evaluation with Piecewise Linear Functions|[mod](bidpwl/bidpwl-scalar.mod) [gms](bidpwl/bidpwl-scalar.gms) [py](bidpwl/bidpwl-scalar.py) [jl](bidpwl/bidpwl-scalar.jl)|31|39|14|89|0|
|386|[trnspwlx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_trnspwlx.html)|MIP|A Transportation Problem with Piecewise Linear Functions|[mod](trnspwlx/trnspwlx-scalar.mod) [gms](trnspwlx/trnspwlx-scalar.gms) [py](trnspwlx/trnspwlx-scalar.py) [jl](trnspwlx/trnspwlx-scalar.jl)|6|7|42|19|6|
|387|[cpack](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cpack.html)|QCP|Packing identical size circles in the unit circle|[mod](cpack/cpack-scalar.mod) [gms](cpack/cpack-scalar.gms) [py](cpack/cpack-scalar.py) [jl](cpack/cpack-scalar.jl)|15|11|0|65|65|
|388|[trigx](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_trigx.html)|NLP|Another Trigonometric Example|[mod](trigx/trigx-scalar.mod) [gms](trigx/trigx-scalar.gms) [py](trigx/trigx-scalar.py) [jl](trigx/trigx-scalar.jl)|3|3|0|7|6|
|389|[stablem](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_stablem.html)|MIP|Stable Marriage Problem|[mod](stablem/stablem-scalar.mod) [gms](stablem/stablem-scalar.gms) [py](stablem/stablem-scalar.py) [jl](stablem/stablem-scalar.jl)|24|17|16|97|0|
|391|[tgridmix](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tgridmix.html)|LP|Grid Transportation Problem with Single Submit and Collect Loop|[mod](tgridmix/tgridmix-scalar.mod) [gms](tgridmix/tgridmix-scalar.gms) [py](tgridmix/tgridmix-scalar.py) [jl](tgridmix/tgridmix-scalar.jl)|0|0|0|0|0|
|393|[cesam2](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_cesam2.html)|NLP|Cross Entropy SAM Estimation|[mod](cesam2/cesam2-scalar.mod) [gms](cesam2/cesam2-scalar.gms) [py](cesam2/cesam2-scalar.py) [jl](cesam2/cesam2-scalar.jl)|166|264|0|715|226|
|395|[tricp](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tricp.html)|QCP|Triangular Graph Circle Packing|[mod](tricp/tricp-scalar.mod) [gms](tricp/tricp-scalar.gms) [py](tricp/tricp-scalar.py) [jl](tricp/tricp-scalar.jl)|191|170|0|1|1|
|397|[clad](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_clad.html)|MIP|Computation of Fairs extramarital affairs model estimates|[mod](clad/clad-scalar.mod) [gms](clad/clad-scalar.gms) [py](clad/clad-scalar.py) [jl](clad/clad-scalar.jl)|3|2|601|11|0|
|401|[circpack](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_circpack.html)|NLP|Pack circles in the smallest possible rectangle|[mod](circpack/circpack-scalar.mod) [gms](circpack/circpack-scalar.gms) [py](circpack/circpack-scalar.py) [jl](circpack/circpack-scalar.jl)|29|16|0|89|62|
|402|[tablelayout](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_tablelayout.html)|MIP|Configuring text layout in table cells to minimize table height|[mod](tablelayout/tablelayout-scalar.mod) [gms](tablelayout/tablelayout-scalar.gms) [py](tablelayout/tablelayout-scalar.py) [jl](tablelayout/tablelayout-scalar.jl)|57|59|28|277|0|
|404|[partssupply](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_partssupply.html)|NLP|Parts Supply Problem|[mod](partssupply/partssupply-scalar.mod) [gms](partssupply/partssupply-scalar.gms) [py](partssupply/partssupply-scalar.py) [jl](partssupply/partssupply-scalar.jl)|5|7|0|13|2|
|407|[carseq](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_carseq.html)|MINLP|Car Sequencing|[mod](carseq/carseq-scalar.mod) [gms](carseq/carseq-scalar.gms) [py](carseq/carseq-scalar.py) [jl](carseq/carseq-scalar.jl)|154|198|60|591|176|
|408|[pmedian](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_pmedian.html)|MINLP|P-Median problem|[mod](pmedian/pmedian-scalar.mod) [gms](pmedian/pmedian-scalar.gms) [py](pmedian/pmedian-scalar.py) [jl](pmedian/pmedian-scalar.jl)|90|90|300|270|180|
|409|[sgolfer](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_sgolfer.html)|MINLP|Social Golfer Problem|[mod](sgolfer/sgolfer-scalar.mod) [gms](sgolfer/sgolfer-scalar.gms) [py](sgolfer/sgolfer-scalar.py) [jl](sgolfer/sgolfer-scalar.jl)|41|43|2|165|79|
|410|[dyncge](https://www.gams.com/latest/gamslib_ml/libhtml/gamslib_dyncge.html)|NLP|A Recursive-Dynamic Standard CGE Model|[mod](dyncge/dyncge-scalar.mod) [gms](dyncge/dyncge-scalar.gms) [py](dyncge/dyncge-scalar.py) [jl](dyncge/dyncge-scalar.jl)|116|117|0|529|296|